# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

#### Public Classes

* [`beegfs`](#beegfs): Manage BeeGFS

#### Private Classes

* `beegfs::admon`
* `beegfs::admon::config`
* `beegfs::admon::install`
* `beegfs::admon::service`
* `beegfs::client`
* `beegfs::client::config`
* `beegfs::client::install`
* `beegfs::client::service`
* `beegfs::defaults`
* `beegfs::install`
* `beegfs::meta`
* `beegfs::meta::config`
* `beegfs::meta::install`
* `beegfs::meta::service`
* `beegfs::mgmtd`
* `beegfs::mgmtd::config`
* `beegfs::mgmtd::install`
* `beegfs::mgmtd::service`
* `beegfs::params`
* `beegfs::repo`
* `beegfs::storage`
* `beegfs::storage::config`
* `beegfs::storage::install`
* `beegfs::storage::service`

## Classes

### <a name="beegfs"></a>`beegfs`

Manage BeeGFS

#### Examples

##### 

```puppet
include beegfs
```

#### Parameters

The following parameters are available in the `beegfs` class:

* [`client`](#client)
* [`mgmtd`](#mgmtd)
* [`meta`](#meta)
* [`storage`](#storage)
* [`admon`](#admon)
* [`utils_only`](#utils_only)
* [`customer_login`](#customer_login)
* [`release`](#release)
* [`version`](#version)
* [`repo_descr`](#repo_descr)
* [`repo_baseurl`](#repo_baseurl)
* [`repo_gpgkey`](#repo_gpgkey)
* [`repo_gpgcheck`](#repo_gpgcheck)
* [`repo_enabled`](#repo_enabled)
* [`client_package_dependencies`](#client_package_dependencies)
* [`manage_client_dependencies`](#manage_client_dependencies)
* [`mgmtd_host`](#mgmtd_host)
* [`conn_port_shift`](#conn_port_shift)
* [`client_conn_interfaces`](#client_conn_interfaces)
* [`client_conn_interfaces_file`](#client_conn_interfaces_file)
* [`mgmtd_conn_interfaces`](#mgmtd_conn_interfaces)
* [`mgmtd_conn_interfaces_file`](#mgmtd_conn_interfaces_file)
* [`meta_conn_interfaces`](#meta_conn_interfaces)
* [`meta_conn_interfaces_file`](#meta_conn_interfaces_file)
* [`storage_conn_interfaces`](#storage_conn_interfaces)
* [`storage_conn_interfaces_file`](#storage_conn_interfaces_file)
* [`admon_conn_interfaces`](#admon_conn_interfaces)
* [`admon_conn_interfaces_file`](#admon_conn_interfaces_file)
* [`client_conn_net_filters`](#client_conn_net_filters)
* [`client_conn_net_filter_file`](#client_conn_net_filter_file)
* [`mgmtd_conn_net_filters`](#mgmtd_conn_net_filters)
* [`mgmtd_conn_net_filter_file`](#mgmtd_conn_net_filter_file)
* [`meta_conn_net_filters`](#meta_conn_net_filters)
* [`meta_conn_net_filter_file`](#meta_conn_net_filter_file)
* [`storage_conn_net_filters`](#storage_conn_net_filters)
* [`storage_conn_net_filter_file`](#storage_conn_net_filter_file)
* [`admon_conn_net_filters`](#admon_conn_net_filters)
* [`admon_conn_net_filter_file`](#admon_conn_net_filter_file)
* [`conn_tcp_only_filters`](#conn_tcp_only_filters)
* [`conn_tcp_only_filter_file`](#conn_tcp_only_filter_file)
* [`ib_package`](#ib_package)
* [`with_rdma`](#with_rdma)
* [`client_mount_path`](#client_mount_path)
* [`manage_client_mount_path`](#manage_client_mount_path)
* [`client_build_args`](#client_build_args)
* [`client_build_enabled`](#client_build_enabled)
* [`client_config_overrides`](#client_config_overrides)
* [`helperd_config_overrides`](#helperd_config_overrides)
* [`client_package`](#client_package)
* [`helperd_package`](#helperd_package)
* [`utils_package`](#utils_package)
* [`client_manage_service`](#client_manage_service)
* [`client_service_name`](#client_service_name)
* [`helperd_service_name`](#helperd_service_name)
* [`client_service_ensure`](#client_service_ensure)
* [`client_service_enable`](#client_service_enable)
* [`client_service_autorestart`](#client_service_autorestart)
* [`mgmtd_store_directory`](#mgmtd_store_directory)
* [`mgmtd_config_overrides`](#mgmtd_config_overrides)
* [`mgmtd_package`](#mgmtd_package)
* [`mgmtd_manage_service`](#mgmtd_manage_service)
* [`mgmtd_service_name`](#mgmtd_service_name)
* [`mgmtd_service_ensure`](#mgmtd_service_ensure)
* [`mgmtd_service_enable`](#mgmtd_service_enable)
* [`mgmtd_service_autorestart`](#mgmtd_service_autorestart)
* [`meta_store_directory`](#meta_store_directory)
* [`meta_config_overrides`](#meta_config_overrides)
* [`meta_package`](#meta_package)
* [`meta_manage_service`](#meta_manage_service)
* [`meta_service_name`](#meta_service_name)
* [`meta_service_ensure`](#meta_service_ensure)
* [`meta_service_enable`](#meta_service_enable)
* [`meta_service_autorestart`](#meta_service_autorestart)
* [`storage_store_directory`](#storage_store_directory)
* [`storage_config_overrides`](#storage_config_overrides)
* [`storage_package`](#storage_package)
* [`storage_manage_service`](#storage_manage_service)
* [`storage_service_name`](#storage_service_name)
* [`storage_service_ensure`](#storage_service_ensure)
* [`storage_service_enable`](#storage_service_enable)
* [`storage_service_autorestart`](#storage_service_autorestart)
* [`admon_database_file_dir`](#admon_database_file_dir)
* [`admon_config_overrides`](#admon_config_overrides)
* [`admon_package`](#admon_package)
* [`admon_manage_service`](#admon_manage_service)
* [`admon_service_name`](#admon_service_name)
* [`admon_service_ensure`](#admon_service_ensure)
* [`admon_service_enable`](#admon_service_enable)
* [`admon_service_autorestart`](#admon_service_autorestart)

##### <a name="client"></a>`client`

Data type: `Boolean`

Boolean that determines if managing BeeGFS client components

Default value: ``true``

##### <a name="mgmtd"></a>`mgmtd`

Data type: `Boolean`

Boolean that determines if managing BeeGFS Mgmtd components

Default value: ``false``

##### <a name="meta"></a>`meta`

Data type: `Boolean`

Boolean that determines if managing BeeGFS Meta components

Default value: ``false``

##### <a name="storage"></a>`storage`

Data type: `Boolean`

Boolean that determines if managing BeeGFS Storage components

Default value: ``false``

##### <a name="admon"></a>`admon`

Data type: `Boolean`

Boolean that determines if managing BeeGFS Admon components

Default value: ``false``

##### <a name="utils_only"></a>`utils_only`

Data type: `Boolean`

Boolean that determines if only BeeGFS utility packages are deployed, ie do not deploy daemons or configs

Default value: ``false``

##### <a name="customer_login"></a>`customer_login`

Data type: `Optional[String]`

The login to use for commercial access to BeeGFS repos

Default value: ``undef``

##### <a name="release"></a>`release`

Data type: `String`

The release of BeeGFS to install

Default value: `'7.1'`

##### <a name="version"></a>`version`

Data type: `String`

The version of BeeGFS to install

Default value: `'present'`

##### <a name="repo_descr"></a>`repo_descr`

Data type: `Optional[String]`

The BeeGFS repo descr

Default value: ``undef``

##### <a name="repo_baseurl"></a>`repo_baseurl`

Data type: `Optional[String]`

The BeeGFS repo baseurl

Default value: ``undef``

##### <a name="repo_gpgkey"></a>`repo_gpgkey`

Data type: `Optional[String]`

The BeeGFS repo gpgkey

Default value: ``undef``

##### <a name="repo_gpgcheck"></a>`repo_gpgcheck`

Data type: `Enum['0','1']`

The BeeGFS repo gpgcheck

Default value: `'0'`

##### <a name="repo_enabled"></a>`repo_enabled`

Data type: `Enum['0','1']`

The BeeGFS repo enabled

Default value: `'1'`

##### <a name="client_package_dependencies"></a>`client_package_dependencies`

Data type: `Array`

The package dependencies for BeeGFS client

Default value: `$beegfs::params::client_package_dependencies`

##### <a name="manage_client_dependencies"></a>`manage_client_dependencies`

Data type: `Boolean`

Boolean that sets if BeeGFS client dependencies will be managed

Default value: ``true``

##### <a name="mgmtd_host"></a>`mgmtd_host`

Data type: `String`

The BeeGFS mgmtd host

Default value: `''`

##### <a name="conn_port_shift"></a>`conn_port_shift`

Data type: `Integer`

The configuration value for connPortShift

Default value: `0`

##### <a name="client_conn_interfaces"></a>`client_conn_interfaces`

Data type: `Array`

The values used to define connInterfacesFile on clients
Mutially exclusive with client_conn_interfaces_file

Default value: `[]`

##### <a name="client_conn_interfaces_file"></a>`client_conn_interfaces_file`

Data type: `Stdlib::Absolutepath`

The value for connInterfacesFile on clients
Mutially exclusive with client_conn_interfaces

Default value: `$beegfs::params::conn_interfaces_file['client']`

##### <a name="mgmtd_conn_interfaces"></a>`mgmtd_conn_interfaces`

Data type: `Array`

The values used to define connInterfacesFile on mgmtd
Mutially exclusive with mgmtd_conn_interfaces_file

Default value: `[]`

##### <a name="mgmtd_conn_interfaces_file"></a>`mgmtd_conn_interfaces_file`

Data type: `Stdlib::Absolutepath`

The value for connInterfacesFile on mgmtd
Mutially exclusive with mgmtd_conn_interfaces

Default value: `$beegfs::params::conn_interfaces_file['mgmtd']`

##### <a name="meta_conn_interfaces"></a>`meta_conn_interfaces`

Data type: `Array`

The values used to define connInterfacesFile on metadata
Mutially exclusive with meta_conn_interfaces_file

Default value: `[]`

##### <a name="meta_conn_interfaces_file"></a>`meta_conn_interfaces_file`

Data type: `Stdlib::Absolutepath`

The value for connInterfacesFile on metadata
Mutially exclusive with meta_conn_interfaces

Default value: `$beegfs::params::conn_interfaces_file['meta']`

##### <a name="storage_conn_interfaces"></a>`storage_conn_interfaces`

Data type: `Array`

The values used to define connInterfacesFile on storage
Mutially exclusive with storage_conn_interfaces_file

Default value: `[]`

##### <a name="storage_conn_interfaces_file"></a>`storage_conn_interfaces_file`

Data type: `Stdlib::Absolutepath`

The value for connInterfacesFile on storage
Mutially exclusive with storage_conn_interfaces

Default value: `$beegfs::params::conn_interfaces_file['storage']`

##### <a name="admon_conn_interfaces"></a>`admon_conn_interfaces`

Data type: `Array`

The values used to define connInterfacesFile on admon
Mutially exclusive with admon_conn_interfaces_file

Default value: `[]`

##### <a name="admon_conn_interfaces_file"></a>`admon_conn_interfaces_file`

Data type: `Stdlib::Absolutepath`

The value for connInterfacesFile on admon
Mutially exclusive with admon_conn_interfaces

Default value: `$beegfs::params::conn_interfaces_file['admon']`

##### <a name="client_conn_net_filters"></a>`client_conn_net_filters`

Data type: `Array`

The value used to define connNetFilterFile on clients
Mutially exclusive with client_conn_net_filter_file

Default value: `[]`

##### <a name="client_conn_net_filter_file"></a>`client_conn_net_filter_file`

Data type: `Stdlib::Absolutepath`

The value for connNetFilterFile on clients
Mutially exclusive with client_conn_net_filter

Default value: `$beegfs::params::conn_net_filter_file['client']`

##### <a name="mgmtd_conn_net_filters"></a>`mgmtd_conn_net_filters`

Data type: `Array`

The value used to define connNetFilterFile on mgmtd
Mutially exclusive with mgmtd_conn_net_filter_file

Default value: `[]`

##### <a name="mgmtd_conn_net_filter_file"></a>`mgmtd_conn_net_filter_file`

Data type: `Stdlib::Absolutepath`

The value for connNetFilterFile on mgmtd
Mutially exclusive with mgmtd_conn_net_filter

Default value: `$beegfs::params::conn_net_filter_file['mgmtd']`

##### <a name="meta_conn_net_filters"></a>`meta_conn_net_filters`

Data type: `Array`

The value used to define connNetFilterFile on metadata
Mutially exclusive with meta_conn_net_filter_file

Default value: `[]`

##### <a name="meta_conn_net_filter_file"></a>`meta_conn_net_filter_file`

Data type: `Stdlib::Absolutepath`

The value for connNetFilterFile on metadata
Mutially exclusive with meta_conn_net_filter

Default value: `$beegfs::params::conn_net_filter_file['meta']`

##### <a name="storage_conn_net_filters"></a>`storage_conn_net_filters`

Data type: `Array`

The value used to define connNetFilterFile on storage
Mutially exclusive with storage_conn_net_filter_file

Default value: `[]`

##### <a name="storage_conn_net_filter_file"></a>`storage_conn_net_filter_file`

Data type: `Stdlib::Absolutepath`

The value for connNetFilterFile on storage
Mutially exclusive with storage_conn_net_filter

Default value: `$beegfs::params::conn_net_filter_file['storage']`

##### <a name="admon_conn_net_filters"></a>`admon_conn_net_filters`

Data type: `Array`

The value used to define connNetFilterFile on admon
Mutially exclusive with admon_conn_net_filter_file

Default value: `[]`

##### <a name="admon_conn_net_filter_file"></a>`admon_conn_net_filter_file`

Data type: `Stdlib::Absolutepath`

The value for connNetFilterFile on admon
Mutially exclusive with admon_conn_net_filter

Default value: `$beegfs::params::conn_net_filter_file['admon']`

##### <a name="conn_tcp_only_filters"></a>`conn_tcp_only_filters`

Data type: `Array`

The value used to populate /etc/beegfs/tcp-only-filter

Default value: `[]`

##### <a name="conn_tcp_only_filter_file"></a>`conn_tcp_only_filter_file`

Data type: `Stdlib::Absolutepath`

Path to /etc/beegfs/tcp-only-filter

Default value: `$beegfs::params::conn_tcp_only_filter_file`

##### <a name="ib_package"></a>`ib_package`

Data type: `String`

Package name for libbeegfs-ib

Default value: `$beegfs::params::ib_package`

##### <a name="with_rdma"></a>`with_rdma`

Data type: `Boolean`

Enable RDMA support with BeeGFS

Default value: `$beegfs::params::with_rdma`

##### <a name="client_mount_path"></a>`client_mount_path`

Data type: `Stdlib::Absolutepath`

Path to mount BeeGFS filesystem on client

Default value: `'/mnt/beegfs'`

##### <a name="manage_client_mount_path"></a>`manage_client_mount_path`

Data type: `Boolean`

Manage the BeeGFS client mount path

Default value: ``true``

##### <a name="client_build_args"></a>`client_build_args`

Data type: `String`

Value for client buildArgs

Default value: `$beegfs::params::client_build_args`

##### <a name="client_build_enabled"></a>`client_build_enabled`

Data type: `Boolean`

Value for client buildEnabled

Default value: ``true``

##### <a name="client_config_overrides"></a>`client_config_overrides`

Data type: `Hash`

Additional client configurations

Default value: `{}`

##### <a name="helperd_config_overrides"></a>`helperd_config_overrides`

Data type: `Hash`

Additional helperd configurations

Default value: `{}`

##### <a name="client_package"></a>`client_package`

Data type: `String`

Client package name

Default value: `$beegfs::params::client_package`

##### <a name="helperd_package"></a>`helperd_package`

Data type: `String`

Client helperd package name

Default value: `$beegfs::params::helperd_package`

##### <a name="utils_package"></a>`utils_package`

Data type: `String`

Package name for beegfs utils

Default value: `$beegfs::params::utils_package`

##### <a name="client_manage_service"></a>`client_manage_service`

Data type: `Boolean`

Boolean whether to manage client service

Default value: ``true``

##### <a name="client_service_name"></a>`client_service_name`

Data type: `String`

Client service name

Default value: `$beegfs::params::client_service_name`

##### <a name="helperd_service_name"></a>`helperd_service_name`

Data type: `String`

Helperd service name

Default value: `$beegfs::params::helperd_service_name`

##### <a name="client_service_ensure"></a>`client_service_ensure`

Data type: `String`

Client service ensure

Default value: `'running'`

##### <a name="client_service_enable"></a>`client_service_enable`

Data type: `Boolean`

Client service enable

Default value: ``true``

##### <a name="client_service_autorestart"></a>`client_service_autorestart`

Data type: `Boolean`

Boolean to set if client will autorestart on changes

Default value: ``true``

##### <a name="mgmtd_store_directory"></a>`mgmtd_store_directory`

Data type: `Any`

The path to mgmtd storage directory

Default value: `''`

##### <a name="mgmtd_config_overrides"></a>`mgmtd_config_overrides`

Data type: `Hash`

Additional mgmtd configurations

Default value: `{}`

##### <a name="mgmtd_package"></a>`mgmtd_package`

Data type: `String`

The BeeGFS mgmtd package

Default value: `$beegfs::params::mgmtd_package`

##### <a name="mgmtd_manage_service"></a>`mgmtd_manage_service`

Data type: `Boolean`

Boolean to set if mgmtd service is managed

Default value: ``true``

##### <a name="mgmtd_service_name"></a>`mgmtd_service_name`

Data type: `String`

The BeeGFS mgmtd service name

Default value: `$beegfs::params::mgmtd_service_name`

##### <a name="mgmtd_service_ensure"></a>`mgmtd_service_ensure`

Data type: `String`

The beegfs-mgmtd service ensure

Default value: `'running'`

##### <a name="mgmtd_service_enable"></a>`mgmtd_service_enable`

Data type: `Boolean`

The beegfs-mgmtd service enable

Default value: ``true``

##### <a name="mgmtd_service_autorestart"></a>`mgmtd_service_autorestart`

Data type: `Boolean`

Boolean to set if beegfs-mgmtd will autorestart on changes

Default value: ``false``

##### <a name="meta_store_directory"></a>`meta_store_directory`

Data type: `Any`

The BeeGFS metadata storage directory

Default value: `''`

##### <a name="meta_config_overrides"></a>`meta_config_overrides`

Data type: `Hash`

Additional metadata configurations

Default value: `{}`

##### <a name="meta_package"></a>`meta_package`

Data type: `String`

The BeeGFS metadata package

Default value: `$beegfs::params::meta_package`

##### <a name="meta_manage_service"></a>`meta_manage_service`

Data type: `Boolean`

Boolean to set if beegfs-meta service is managed

Default value: ``true``

##### <a name="meta_service_name"></a>`meta_service_name`

Data type: `String`

The BeeGFS metadata service name

Default value: `$beegfs::params::meta_service_name`

##### <a name="meta_service_ensure"></a>`meta_service_ensure`

Data type: `String`

The beegfs-meta service ensure

Default value: `'running'`

##### <a name="meta_service_enable"></a>`meta_service_enable`

Data type: `Boolean`

The beegfs-meta service enable

Default value: ``true``

##### <a name="meta_service_autorestart"></a>`meta_service_autorestart`

Data type: `Boolean`

Boolean to set if beegfs-meta will autorestart on changes

Default value: ``false``

##### <a name="storage_store_directory"></a>`storage_store_directory`

Data type: `Any`

The BeeGFS storage daemon storage directory

Default value: `''`

##### <a name="storage_config_overrides"></a>`storage_config_overrides`

Data type: `Hash`

Additional storage configurations

Default value: `{}`

##### <a name="storage_package"></a>`storage_package`

Data type: `String`

The BeeGFS storage package name

Default value: `$beegfs::params::storage_package`

##### <a name="storage_manage_service"></a>`storage_manage_service`

Data type: `Boolean`

Boolean to set if beegfs-storage service is managed

Default value: ``true``

##### <a name="storage_service_name"></a>`storage_service_name`

Data type: `String`

The BeeGFS storage service name

Default value: `$beegfs::params::storage_service_name`

##### <a name="storage_service_ensure"></a>`storage_service_ensure`

Data type: `String`

The beegfs-storage service ensure

Default value: `'running'`

##### <a name="storage_service_enable"></a>`storage_service_enable`

Data type: `Boolean`

The beegfs-storage service enable

Default value: ``true``

##### <a name="storage_service_autorestart"></a>`storage_service_autorestart`

Data type: `Boolean`

Boolean to set if beegfs-storage will autorestart on changes

Default value: ``false``

##### <a name="admon_database_file_dir"></a>`admon_database_file_dir`

Data type: `Stdlib::Absolutepath`

The path to BeeGFS admon database directory

Default value: `'/var/lib/beegfs'`

##### <a name="admon_config_overrides"></a>`admon_config_overrides`

Data type: `Hash`

Additional BeeGFS Admon configurations

Default value: `{}`

##### <a name="admon_package"></a>`admon_package`

Data type: `String`

The BeeGFS Admon package name

Default value: `$beegfs::params::admon_package`

##### <a name="admon_manage_service"></a>`admon_manage_service`

Data type: `Boolean`

Boolean to set if beegfs-admon service is managed

Default value: ``true``

##### <a name="admon_service_name"></a>`admon_service_name`

Data type: `String`

The BeeGFS Admon service name

Default value: `$beegfs::params::admon_service_name`

##### <a name="admon_service_ensure"></a>`admon_service_ensure`

Data type: `String`

The beegfs-admon service ensure

Default value: `'running'`

##### <a name="admon_service_enable"></a>`admon_service_enable`

Data type: `Boolean`

The beegfs-admon service enable

Default value: ``true``

##### <a name="admon_service_autorestart"></a>`admon_service_autorestart`

Data type: `Boolean`

Boolean to set if beegfs-admon will autorestart on changes

Default value: ``false``

