# @api private
class beegfs::defaults {

  # lint:ignore:quoted_booleans
  $mgmtd_default_configs = {
    '7.1' => {
      'storeMgmtdDirectory' => '',
      'storeAllowFirstRunInit' => 'true',
      'sysAllowNewServers' => 'true',
      'sysAllowNewTargets' => 'true',
      'connAuthFile' => '',
      'connBacklogTCP' => '128',
      'connInterfacesFile' => '',
      'connMgmtdPortTCP' => '8008',
      'connMgmtdPortUDP' => '8008',
      'connNetFilterFile' => '',
      'connPortShift' => '0',
      'logType' => 'logfile',
      'logLevel' => '2',
      'logNoDate' => 'false',
      'logNumLines' => '50000',
      'logNumRotatedFiles' => '5',
      'logStdFile' => '/var/log/beegfs-mgmtd.log',
      'quotaQueryGIDFile' => '',
      'quotaQueryGIDRange' => '',
      'quotaQueryUIDFile' => '',
      'quotaQueryUIDRange' => '',
      'quotaQueryType' => 'system',
      'quotaQueryWithSystemUsersGroups' => 'false',
      'quotaUpdateIntervalMin' => '10',
      'runDaemonized' => 'true',
      'sysTargetOfflineTimeoutSecs' => '180',
      'tuneClientAutoRemoveMins' => '30',
      'tuneNumWorkers' => '4',
      'tuneMetaDynamicPools' => 'true',
      'tuneMetaInodesLowLimit' => '10M',
      'tuneMetaInodesEmergencyLimit' => '1M',
      'tuneMetaSpaceLowLimit' => '10G',
      'tuneMetaSpaceEmergencyLimit' => '3G',
      'tuneStorageDynamicPools' => 'true',
      'tuneStorageInodesLowLimit' => '10M',
      'tuneStorageInodesEmergencyLimit' => '1M',
      'tuneStorageSpaceLowLimit' => '1T',
      'tuneStorageSpaceEmergencyLimit' => '20G',
      'quotaEnableEnforcement' => 'false',
    },
  }

  $mgmtd_config_keys = {
    '7.1' => {
      'basic'     => [
        'storeMgmtdDirectory',
        'storeAllowFirstRunInit',
        'sysAllowNewServers',
        'sysAllowNewTargets',
      ],
      'advanced'  => [
        'connAuthFile',
        'connBacklogTCP',
        'connInterfacesFile',
        'connMgmtdPortTCP',
        'connMgmtdPortUDP',
        'connNetFilterFile',
        'connPortShift',
        'logType',
        'logLevel',
        'logNoDate',
        'logNumLines',
        'logNumRotatedFiles',
        'logStdFile',
        'quotaQueryGIDFile',
        'quotaQueryGIDRange',
        'quotaQueryUIDFile',
        'quotaQueryUIDRange',
        'quotaQueryType',
        'quotaQueryWithSystemUsersGroups',
        'quotaUpdateIntervalMin',
        'runDaemonized',
        'sysTargetOfflineTimeoutSecs',
        'tuneClientAutoRemoveMins',
        'tuneNumWorkers',
        'tuneMetaDynamicPools',
        'tuneMetaInodesLowLimit',
        'tuneMetaInodesEmergencyLimit',
        'tuneMetaSpaceLowLimit',
        'tuneMetaSpaceEmergencyLimit',
        'tuneStorageDynamicPools',
        'tuneStorageInodesLowLimit',
        'tuneStorageInodesEmergencyLimit',
        'tuneStorageSpaceLowLimit',
        'tuneStorageSpaceEmergencyLimit',
        # Expert
        'tuneProcessFDLimit',
        'pidFile',
      ],
      'enterprise' => [
        'quotaEnableEnforcement',
      ]
    },
  }

  $meta_default_configs = {
    '7.1' => {
      'sysMgmtdHost' => '',
      'storeMetaDirectory' => '',
      'storeAllowFirstRunInit' => 'true',
      'connAuthFile' => '',
      'connBacklogTCP' => '128',
      'connFallbackExpirationSecs' => '900',
      'connInterfacesFile' => '',
      'connMaxInternodeNum' => '32',
      'connMetaPortTCP' => '8005',
      'connMetaPortUDP' => '8005',
      'connMgmtdPortTCP' => '8008',
      'connMgmtdPortUDP' => '8008',
      'connPortShift' => '0',
      'connNetFilterFile' => '',
      'connUseRDMA' => 'true',
      'connRDMATypeOfService' => '0',
      'connTcpOnlyFilterFile' => '',
      'logType' => 'logfile',
      'logLevel' => '3',
      'logNoDate' => 'false',
      'logNumLines' => '50000',
      'logNumRotatedFiles' => '5',
      'logStdFile' => '/var/log/beegfs-meta.log',
      'runDaemonized' => 'true',
      'storeClientXAttrs' => 'false',
      'storeClientACLs' => 'false',
      'storeUseExtendedAttribs' => 'true',
      'sysTargetAttachmentFile' => '',
      'sysTargetOfflineTimeoutSecs' => '180',
      'sysAllowUserSetPattern' => 'false',
      'tuneBindToNumaZone' => '',
      'tuneNumStreamListeners' => '1',
      'tuneNumWorkers' => '0',
      'tuneTargetChooser' => 'randomized',
      'tuneUseAggressiveStreamPoll' => 'false',
      'tuneUsePerUserMsgQueues' => 'false',
    },
  }

  $meta_config_keys = {
    '7.1' => {
      'basic'     => [
        'sysMgmtdHost',
        'storeMetaDirectory',
        'storeAllowFirstRunInit',
      ],
      'advanced'  => [
        'connAuthFile',
        'connBacklogTCP',
        'connFallbackExpirationSecs',
        'connInterfacesFile',
        'connMaxInternodeNum',
        'connMetaPortTCP',
        'connMetaPortUDP',
        'connMgmtdPortTCP',
        'connMgmtdPortUDP',
        'connPortShift',
        'connNetFilterFile',
        'connUseRDMA',
        'connRDMATypeOfService',
        'connTcpOnlyFilterFile',
        'logType',
        'logLevel',
        'logNoDate',
        'logNumLines',
        'logNumRotatedFiles',
        'logStdFile',
        'runDaemonized',
        'storeClientXAttrs',
        'storeClientACLs',
        'storeUseExtendedAttribs',
        'sysTargetAttachmentFile',
        'sysTargetOfflineTimeoutSecs',
        'sysAllowUserSetPattern',
        'tuneBindToNumaZone',
        'tuneNumStreamListeners',
        'tuneNumWorkers',
        'tuneTargetChooser',
        'tuneUseAggressiveStreamPoll',
        'tuneUsePerUserMsgQueues',
        # Expert
        'storeSelfHealEmptyFiles',
        'tuneNumCommSlaves',
        'tuneCommSlaveBufSize',
        'tuneDefaultChunkSize',
        'tuneDefaultNumStripeTargets',
        'tuneProcessFDLimit',
        'tuneWorkerNumaAffinity',
        'tuneListenerNumaAffinity',
        'tuneListenerPrioShift',
        'tuneDirMetadataCacheLimit',
        'tuneLockGrantWaitMS',
        'tuneLockGrantNumRetries',
        'tuneRotateMirrorTargets',
        'tuneEarlyUnlinkResponse',
        'tuneMirrorTimestamps',
        'quotaEarlyChownResponse',
        'pidFile',
      ],
    }
  }

  $storage_default_configs = {
    '7.1' => {
      'sysMgmtdHost' => '',
      'storeStorageDirectory' => '',
      'storeAllowFirstRunInit' => 'true',
      'connAuthFile' => '',
      'connBacklogTCP' => '128',
      'connInterfacesFile' => '',
      'connMaxInternodeNum' => '12',
      'connMgmtdPortTCP' => '8008',
      'connMgmtdPortUDP' => '8008',
      'connStoragePortTCP' => '8003',
      'connStoragePortUDP' => '8003',
      'connPortShift' => '0',
      'connNetFilterFile' => '',
      'connUseRDMA' => 'true',
      'connRDMATypeOfService' => '0',
      'connTcpOnlyFilterFile' => '',
      'logType' => 'logfile',
      'logLevel' => '3',
      'logNoDate' => 'false',
      'logNumLines' => '50000',
      'logNumRotatedFiles' => '5',
      'logStdFile' => '/var/log/beegfs-storage.log',
      'quotaEnableEnforcement' => 'false',
      'runDaemonized' => 'true',
      'sysResyncSafetyThresholdMins' => '10',
      'sysTargetOfflineTimeoutSecs' => '180',
      'tuneBindToNumaZone' => '',
      'tuneFileReadAheadSize' => '0m',
      'tuneFileReadAheadTriggerSize' => '4m',
      'tuneFileReadSize' => '128k',
      'tuneFileWriteSize' => '128k',
      'tuneFileWriteSyncSize' => '0m',
      'tuneNumResyncGatherSlaves' => '6',
      'tuneNumResyncSlaves' => '12',
      'tuneNumStreamListeners' => '1',
      'tuneNumWorkers' => '12',
      'tuneUseAggressiveStreamPoll' => 'false',
      'tuneUsePerTargetWorkers' => 'true',
      'tuneUsePerUserMsgQueues' => 'false',
      'tuneWorkerBufSize' => '4m',
    },
  }

  $storage_config_keys = {
    '7.1' => {
      'basic'     => [
        'sysMgmtdHost',
        'storeStorageDirectory',
        'storeAllowFirstRunInit',
      ],
      'advanced'  => [
        'connAuthFile',
        'connBacklogTCP',
        'connInterfacesFile',
        'connMaxInternodeNum',
        'connMgmtdPortTCP',
        'connMgmtdPortUDP',
        'connStoragePortTCP',
        'connStoragePortUDP',
        'connPortShift',
        'connNetFilterFile',
        'connUseRDMA',
        'connRDMATypeOfService',
        'connTcpOnlyFilterFile',
        'logType',
        'logLevel',
        'logNoDate',
        'logNumLines',
        'logNumRotatedFiles',
        'logStdFile',
        'quotaEnableEnforcement',
        'runDaemonized',
        'sysResyncSafetyThresholdMins',
        'sysTargetOfflineTimeoutSecs',
        'tuneBindToNumaZone',
        'tuneFileReadAheadSize',
        'tuneFileReadAheadTriggerSize',
        'tuneFileReadSize',
        'tuneFileWriteSize',
        'tuneFileWriteSyncSize',
        'tuneNumResyncGatherSlaves',
        'tuneNumResyncSlaves',
        'tuneNumStreamListeners',
        'tuneNumWorkers',
        'tuneUseAggressiveStreamPoll',
        'tuneUsePerTargetWorkers',
        'tuneUsePerUserMsgQueues',
        'tuneWorkerBufSize',
        # Expert
        'tuneProcessFDLimit',
        'tuneWorkerNumaAffinity',
        'tuneListenerNumaAffinity',
        'tuneListenerPrioShift',
        'tuneDirCacheLimit',
        'tuneEarlyStat',
        'quotaDisableZfsSupport',
        'pidFile',
      ],
    }
  }

  $admon_default_configs = {
    '7.1' => {
      'sysMgmtdHost' => '',
      'clearDatabase' => 'false',
      'httpPort' => '8000',
      'databaseFile' => '/var/lib/beegfs/beegfs-admon.db',
      'queryInterval' => '5',
      'connAdmonPortUDP' => '8007',
      'connMgmtdPortTCP' => '8008',
      'connMgmtdPortUDP' => '8008',
      'connPortShift' => '0',
      'connAuthFile' => '',
      'connFallbackExpirationSecs' => '900',
      'connMaxInternodeNum' => '3',
      'connInterfacesFile' => '',
      'connNetFilterFile' => '',
      'connTcpOnlyFilterFile' => '',
      'logType' => 'logfile',
      'logLevel' => '3',
      'logNoDate' => 'false',
      'logNumLines' => '50000',
      'logNumRotatedFiles' => '2',
      'logStdFile' => '/var/log/beegfs-admon.log',
      'mailEnabled' => 'false',
      'mailSmtpSendType' => 'socket',
      'mailSendmailPath' => 'sendmail',
      'mailCheckIntervalTimeSec' => '30',
      'mailMinDownTimeSec' => '10',
      'mailRecipient' => '',
      'mailResendMailTimeMin' => '60',
      'mailSender' => '',
      'mailSmtpServer' => '',
      'runDaemonized' => 'true',
      'tuneNumWorkers' => '4',
    },
  }

  $admon_config_keys = {
    '7.1' => {
      'basic'     => [
        'sysMgmtdHost',
      ],
      'advanced'  => [
        'clearDatabase',
        'httpPort',
        'databaseFile',
        'queryInterval',
        'connAdmonPortUDP',
        'connMgmtdPortTCP',
        'connMgmtdPortUDP',
        'connPortShift',
        'connAuthFile',
        'connFallbackExpirationSecs',
        'connMaxInternodeNum',
        'connInterfacesFile',
        'connNetFilterFile',
        'connTcpOnlyFilterFile',
        'logType',
        'logLevel',
        'logNoDate',
        'logNumLines',
        'logNumRotatedFiles',
        'logStdFile',
        'mailEnabled',
        'mailSmtpSendType',
        'mailSendmailPath',
        'mailCheckIntervalTimeSec',
        'mailMinDownTimeSec',
        'mailRecipient',
        'mailResendMailTimeMin',
        'mailSender',
        'mailSmtpServer',
        'runDaemonized',
        'tuneNumWorkers',
      ],
    }
  }

  $helperd_default_configs = {
    '7.1' => {
      'connAuthFile' => '',
      'connHelperdPortTCP' => '8006',
      'connPortShift' => '0',
      'logNoDate' => 'false',
      'logNumLines' => '50000',
      'logNumRotatedFiles' => '5',
      'logStdFile' => '/var/log/beegfs-client.log',
      'runDaemonized' => 'true',
      'tuneNumWorkers' => '2',
    },
  }

  $helperd_config_keys = {
    '7.1' => [
      'connAuthFile',
      'connHelperdPortTCP',
      'connPortShift',
      'logNoDate',
      'logNumLines',
      'logNumRotatedFiles',
      'logStdFile',
      'runDaemonized',
      'tuneNumWorkers',
      # Expert
      'pidFile',
    ]
  }

  $client_default_configs = {
    '7.1' => {
      'sysMgmtdHost' => '',
      'connAuthFile' => '',
      'connClientPortUDP' => '8004',
      'connHelperdPortTCP' => '8006',
      'connMgmtdPortTCP' => '8008',
      'connMgmtdPortUDP' => '8008',
      'connPortShift' => '0',
      'connCommRetrySecs' => '600',
      'connFallbackExpirationSecs' => '900',
      'connInterfacesFile' => '',
      'connMaxInternodeNum' => '12',
      'connMaxConcurrentAttempts' => '0',
      'connNetFilterFile' => '',
      'connUseRDMA' => 'true',
      'connRDMABufNum' => '70',
      'connRDMABufSize' => '8192',
      'connRDMATypeOfService' => '0',
      'connTcpOnlyFilterFile' => '',
      'logClientID' => 'false',
      'logHelperdIP' => '',
      'logLevel' => '3',
      'logType' => 'helperd',
      'quotaEnabled' => 'false',
      'sysCreateHardlinksAsSymlinks' => 'false',
      'sysMountSanityCheckMS' => '11000',
      'sysSessionCheckOnClose' => 'false',
      'sysSyncOnClose' => 'false',
      'sysTargetOfflineTimeoutSecs' => '900',
      'sysUpdateTargetStatesSecs' => '30',
      'sysXAttrsEnabled' => 'false',
      'tuneFileCacheType' => 'buffered',
      'tunePreferredMetaFile' => '',
      'tunePreferredStorageFile' => '',
      'tuneRemoteFSync' => 'true',
      'tuneUseGlobalAppendLocks' => 'false',
      'tuneUseGlobalFileLocks' => 'false',
      'sysACLsEnabled' => 'false',
    },
  }

  $client_config_keys = {
    '7.1' => {
      'basic'     => [
        'sysMgmtdHost',
      ],
      'advanced'  => [
        'connAuthFile',
        'connClientPortUDP',
        'connHelperdPortTCP',
        'connMgmtdPortTCP',
        'connMgmtdPortUDP',
        'connPortShift',
        'connCommRetrySecs',
        'connFallbackExpirationSecs',
        'connInterfacesFile',
        'connMaxInternodeNum',
        'connMaxConcurrentAttempts',
        'connNetFilterFile',
        'connUseRDMA',
        'connRDMABufNum',
        'connRDMABufSize',
        'connRDMATypeOfService',
        'connTcpOnlyFilterFile',
        'logClientID',
        'logHelperdIP',
        'logLevel',
        'logType',
        'quotaEnabled',
        'sysCreateHardlinksAsSymlinks',
        'sysMountSanityCheckMS',
        'sysSessionCheckOnClose',
        'sysSyncOnClose',
        'sysTargetOfflineTimeoutSecs',
        'sysUpdateTargetStatesSecs',
        'sysXAttrsEnabled',
        'tuneFileCacheType',
        'tunePreferredMetaFile',
        'tunePreferredStorageFile',
        'tuneRemoteFSync',
        'tuneUseGlobalAppendLocks',
        'tuneUseGlobalFileLocks',
        # Expert
        'connUnmountRetries',
        'tuneFileCacheBufSize',
        'tuneFileCacheBufNum',
        'tunePageCacheValidityMS',
        'tuneDirSubentryCacheValidityMS',
        'tuneFileSubentryCacheValidityMS',
        'tunePathBufSize',
        'tunePathBufNum',
        'tuneMsgBufSize',
        'tuneMsgBufNum',
        'tuneRefreshOnGetAttr',
        'tuneInodeBlockBits',
        'tuneEarlyCloseResponse',
        'tuneUseBufferedAppend',
        'tuneStatFsCacheSecs',
        'sysInodeIDStyle',
      ],
      'enterprise' => [
        'sysACLsEnabled',
      ],
    }
  }
  # lint:endignore
}
